; $id$
;
; License: GPL-3

(declare (export))

(use svnwiki-extensions-support srfi-40 stream-ext html-stream format-modular stream-wiki)

(define (tag-description-set env)
  (let-from-environment env (output-format text)
    (case output-format
      ((description)
       (let-from-environment env (return)
         (return (stream-drop-while char-whitespace? text))
         stream-null))
      (else
       (let-from-environment env (parse)
         (parse text))))))

(define (tag-description-load env)
  (let-from-environment env (parse params path-in path)
    (let ((path-target (assoc 'path params)))
      (if path-target
        (parse
          (stream-translate
            (stream-concatenate
              (iterator->stream
                (lambda (return stop)
                  (let ((path (stream->string (link-canonical path (cdr path-target)))))
                    (wiki-extension
                      'description
                      (wiki-open path-in path)
                      stream-null
                      path
                      (constantly stream-null)
                      (lambda (name tail) tail)
                      (make-hash-table)
                      (environment-capture env (return path)))))))
            #\newline
            #\space))
        (html-stream "[listpage: error: param path missing]")))))

(svnwiki-extension-define 'code-span 'description tag-description-set)
(svnwiki-extension-define 'code-break 'description tag-description-load)
